﻿using System.Collections.Generic;
using System.Text;
using RimWorld;
using Verse;


namespace Mincho_The_Mint_Choco_Slime
{
    public class Alert_Mincho_Melt : Alert
    {
        public Alert_Mincho_Melt()
        {
            defaultLabel = "AlertMincho_Melt".Translate();
            defaultPriority = AlertPriority.High;
        }

        private List<Pawn> Mincho_MeltPawns
        {
            get
            {
                Mincho_MeltPawnsResult.Clear();
                List<Pawn> list = PawnsFinder.AllMaps_SpawnedPawnsInFaction(Faction.OfPlayer);
                for (int i = 0; i < list.Count; i++)
                {
                    Pawn pawn = list[i];
                    if (pawn.health != null && !pawn.RaceProps.Animal && pawn.health.hediffSet.GetFirstHediffOfDef(MinchoDefOf.Mincho_Melt, true) != null)
                    {
                        Mincho_MeltPawnsResult.Add(pawn);
                    }
                }
                return Mincho_MeltPawnsResult;
            }
        }

        public override TaggedString GetExplanation()
        {
            StringBuilder stringBuilder = new StringBuilder();
            foreach (Pawn pawn in Mincho_MeltPawns)
            {
                stringBuilder.AppendLine("  - " + pawn.NameShortColored.Resolve());
            }
            return string.Format("AlertMincho_MeltDesc".Translate(), stringBuilder.ToString());
        }

        public override AlertReport GetReport()
        {
            return AlertReport.CulpritsAre(Mincho_MeltPawns);
        }
        private List<Pawn> Mincho_MeltPawnsResult = new List<Pawn>();
    }
}