﻿using System;
using AlienRace;
using HarmonyLib;
using Verse;

namespace Mincho_The_Mint_Choco_Slime
{
    [StaticConstructorOnStartup]
    public static class ChangeLook_Harmony_Age
    {
        static ChangeLook_Harmony_Age()
        {
            Harmony harmonyInstance = new Harmony("Mincho_The_Mint_Choco_Slime");
            harmonyInstance.Patch(AccessTools.Method(typeof(Pawn_AgeTracker), "BirthdayBiological", null, null), null, new HarmonyMethod(patchType, "BirthdayBiologicalPostFix", null), null, null);
            harmonyInstance.Patch(AccessTools.Method(typeof(Pawn_AgeTracker), "RecalculateLifeStageIndex", null, null), null, new HarmonyMethod(patchType, "RecalculateLifeStageIndexPostfix", null), null, null);
            Log.Message("Mincho_The_Mint_Choco_Slime_patched", false);
        }

        [HarmonyPostfix]
        public static void BirthdayBiologicalPostFix(Pawn ___pawn)
        {
            foreach (ChangeLookDef changeLook in DefDatabase<ChangeLookDef>.AllDefs)
            {
                if (changeLook.targetRace == ___pawn.def)
                {
                    ThingComp_ChangeWithAge thingComp_ChangeWithAge = ___pawn.TryGetComp<ThingComp_ChangeWithAge>();
                    thingComp_ChangeWithAge.bodycheck = true;
                    thingComp_ChangeWithAge.BirthdayBiologicalPostFixTestError = true;
                }
            }
        }

        [HarmonyPostfix]
        public static void RecalculateLifeStageIndexPostfix(Pawn_AgeTracker __instance)
        {
            Pawn value;

            if (Current.ProgramState == ProgramState.Playing && (value = Traverse.Create(__instance).Field("pawn").GetValue<Pawn>()).def is ThingDef_AlienRace && value.Drawer.renderer.graphics.AllResolved)
            {
                foreach (ChangeLookDef changeLook in DefDatabase<ChangeLookDef>.AllDefs)
                {
                    if (changeLook.targetRace == value.def)
                    {
                        ThingComp_ChangeWithAge thingComp_ChangeWithAge = value.TryGetComp<ThingComp_ChangeWithAge>();
                        thingComp_ChangeWithAge.bodycheck = true;
                        thingComp_ChangeWithAge.RecalculateLifeStageIndexPostFixTestError = true;
                    }
                }
            }
        }
        private static readonly Type patchType = typeof(ChangeLook_Harmony_Age);
    }
}
