﻿using System.Collections.Generic;
using RimWorld;
using UnityEngine;
using Verse;

//original code by NukaFrog
namespace Mincho_The_Mint_Choco_Slime
{
    [StaticConstructorOnStartup]
    public class CompFireOverlayRotatable : CompFireOverlay
    {
        List<Rot4> showList = new List<Rot4>();
        public CompFlickable compFlickable;
        public CompPowerTrader compPower;
        public override void PostDraw()
        {
            foreach (Rot4 rot in showList)
            {
                if (rot == parent.Rotation)
                {
                    if (compPower != null)
                    {
                        if (compPower.PowerOn)
                        {
                            DrawCall();
                        }
                    }
                    else
                    {
                        if (refuelableComp != null)
                        {
                            if (refuelableComp.HasFuel && compFlickable.SwitchIsOn)
                            {
                                DrawCall();
                            }
                        }
                        else
                        {
                            if (compFlickable.SwitchIsOn)
                            {
                                DrawCall();
                            }
                        }
                    }
                    return;
                }
            }
        }

        public void DrawCall()
        {
            Vector3 drawPos = parent.DrawPos;
            drawPos.y += 0.046875f;
            FireGraphic.Draw(drawPos, Rot4.North, parent, 0f);
        }

        public override void PostSpawnSetup(bool respawningAfterLoad)
        {
            base.PostSpawnSetup(respawningAfterLoad);
            showList = ((CompProperties_FireOverlayRotatable)props).showRotateList;
            compFlickable = parent.GetComp<CompFlickable>();
            compPower = parent.GetComp<CompPowerTrader>();
        }
    }
    public class CompProperties_FireOverlayRotatable : CompProperties_FireOverlay
    {
        public List<Rot4> showRotateList = new List<Rot4>();
        public override void ResolveReferences(ThingDef parentDef)
        {
            base.ResolveReferences(parentDef);
            if (showRotateList.Count > 0)
            {
                return;
            }
            showRotateList.Add(Rot4.North);
            showRotateList.Add(Rot4.South);
            showRotateList.Add(Rot4.East);
            showRotateList.Add(Rot4.West);
        }
    }

}
