﻿using RimWorld;
using Verse;

namespace Mincho_The_Mint_Choco_Slime
{
    public class DeathActionWorker_DestroyCorpse : DeathActionWorker
    {
        public override bool DangerousInMelee
        {
            get
            {
                return false;
            }
        }
        public override void PawnDied(Corpse corpse)
        {
            if (corpse.InnerPawn.IsColonist)
            {
                FilthMaker.TryMakeFilth(corpse.Position, corpse.Map, MinchoDefOf.Mincho_Filth_BloodDef, 5, FilthSourceFlags.None);
                Thing thing = ThingMaker.MakeThing(MinchoDefOf.Mincho_Mintchoco, null);
                thing.stackCount = 40;
                GenPlace.TryPlaceThing(thing, corpse.Position, corpse.Map, 0, null, null, default);
                corpse.InnerPawn.equipment.DropAllEquipment(corpse.Position, true);
                corpse.InnerPawn.apparel.DropAll(corpse.Position, true, true);
                corpse.Destroy(0);
            }
            else
            {
                FilthMaker.TryMakeFilth(corpse.Position, corpse.Map, MinchoDefOf.Mincho_Filth_BloodDef, 5, FilthSourceFlags.None);
                Thing thing = ThingMaker.MakeThing(MinchoDefOf.Mincho_Mintchoco, null);
                thing.stackCount = 5;
                GenPlace.TryPlaceThing(thing, corpse.Position, corpse.Map, 0, null, null, default);
                corpse.InnerPawn.equipment.DropAllEquipment(corpse.Position, true);
                corpse.InnerPawn.apparel.DropAll(corpse.Position, true, true);
                corpse.Destroy(0);
            }
        }
    }

    public class DeathActionWorker_DestroyCorpse_Animal : DeathActionWorker
    {
        public override bool DangerousInMelee
        {
            get
            {
                return false;
            }
        }
        public override void PawnDied(Corpse corpse)
        {
            FilthMaker.TryMakeFilth(corpse.Position, corpse.Map, MinchoDefOf.Mincho_Filth_BloodDef, 5, FilthSourceFlags.None);
            Thing thing = ThingMaker.MakeThing(MinchoDefOf.Mincho_Mintchoco, null);
            thing.stackCount = (int)(40 * corpse.InnerPawn.BodySize);
            GenPlace.TryPlaceThing(thing, corpse.Position, corpse.Map, 0, null, null, default);
            corpse.InnerPawn.DropAndForbidEverything();
            corpse.Destroy(0);
        }
    }
}