﻿using System;
using System.Collections.Generic;
using Verse;

namespace Mincho_The_Mint_Choco_Slime
{
    public class HediffCompProperties_AutoRecovery : HediffCompProperties
    {
        public int tickMultiflier = 1800;
        public float healPoint = 1;
        public HediffCompProperties_AutoRecovery()
        {
            compClass = typeof(HediffComp_AutoRecovery);
        }
    }

    public class HediffComp_AutoRecovery : HediffComp
    {
        private int ticksToHeal;
        private float healPoint;
        public static Func<Hediff, bool> func;
        public HediffCompProperties_AutoRecovery Props
        {
            get
            {
                return (HediffCompProperties_AutoRecovery)props;
            }
        }

        public override void CompPostMake()
        {
            base.CompPostMake();
            ResetTicksToHeal();
        }

        private void ResetTicksToHeal()
        {
            // Rand.Range(1, 3) *
            healPoint = Props.healPoint;
            ticksToHeal = Props.tickMultiflier;
        }
        public override void CompPostTick(ref float severityAdjustment)
        {
            ticksToHeal--;
            if (ticksToHeal <= 0)
            {
                TryHealRandomPermanentWound();
                TryHealRandomHediffTendable();
                ResetTicksToHeal();
            }
        }

        private void TryHealRandomPermanentWound()
        {
            IEnumerable<Hediff> hediffs = Pawn.health.hediffSet.hediffs;
            foreach (Hediff hediff in hediffs)
            {
                if (hediff.def.isBad && hediff.IsPermanent())
                {
                    hediff.Severity -= healPoint;
                }
            }
        }
        private void TryHealRandomHediffTendable()
        {
            IEnumerable<Hediff> hediffs = Pawn.health.hediffSet.hediffs;
            foreach (Hediff hediff in hediffs)
            {
                if (hediff.def.defName != "Scaria" && hediff.def.isBad && (hediff.IsPermanent() || hediff.def.chronic || hediff.def.tendable || hediff.def.makesSickThought))
                {
                    hediff.Heal(healPoint);
                    if (hediff.Severity <= 0.003)
                    {
                        HealthUtility.CureHediff(hediff);
                        return;
                    }

                }

            }
        }

        public override void CompExposeData()
        {
            Scribe_Values.Look(ref ticksToHeal, "ticksToHeal", 0, false);
        }

        public override string CompDebugString()
        {
            return "ticksToHeal: " + ticksToHeal;
        }
    }
}
