﻿using System.Collections.Generic;
using System.Linq;
using Verse;

namespace Mincho_The_Mint_Choco_Slime
{
    public class HediffCompProperties_HealMincho_Humanlike_Body_Hediff : HediffCompProperties
    {
        public List<HediffDef> healHediffDef = new List<HediffDef>();
        public HediffCompProperties_HealMincho_Humanlike_Body_Hediff()
        {
            compClass = typeof(HediffComp_HealMincho_Humanlike_Body_Hediff);
        }
    }
    public class HediffComp_HealMincho_Humanlike_Body_Hediff : HediffComp
    {
        public HediffCompProperties_HealMincho_Humanlike_Body_Hediff Props
        {
            get
            {
                return (HediffCompProperties_HealMincho_Humanlike_Body_Hediff)props;
            }
        }
        public override void CompPostMake()
        {
            base.CompPostMake();
            ResetTicksToHeal();
        }

        private void ResetTicksToHeal()
        {
            ticksToHeal = 1;
        }

        public override void CompPostTick(ref float severityAdjustment)
        {
            ticksToHeal--;
            if (ticksToHeal <= 0)
            {
                TryHealRandomPermanentWound();
                ResetTicksToHeal();
            }
        }

        private void TryHealRandomPermanentWound()
        {

            Hediff hediff;
            if (!(from hd in Pawn.health.hediffSet.hediffs
                  where Props.healHediffDef.Contains(hd.def)
                  select hd).TryRandomElement(out hediff))
            {
                return;
            }
            HealthUtility.CureHediff(hediff);
        }

        public override void CompExposeData()
        {
            Scribe_Values.Look<int>(ref ticksToHeal, "ticksToHeal", 0, false);
        }

        public override string CompDebugString()
        {
            return "ticksToHeal: " + ticksToHeal;
        }

        private int ticksToHeal;
    }
}
