﻿using System.Linq;
using RimWorld;
using Verse;

namespace Mincho_The_Mint_Choco_Slime
{
    public class MinchoComp : ThingComp
    {
        public override void CompTickRare()
        {
            if (Pawn != null && Pawn.Spawned)
            {
                base.CompTickRare();
                //에일리언용. 이거는 예전에 시바님을 위해 만든게 있으니 그거 참조...
                if (Pawn.def.defName == "Mincho_ThingDef" && !Pawn.health.hediffSet.GetNotMissingParts(0, 0, null, null).Any((BodyPartRecord x) => x.def.defName == "Head"))
                {
                    BodyPartRecord part = Pawn.health.hediffSet.GetMissingPartsCommonAncestors().Find((Hediff_MissingPart x) => x.Part.def.defName == "Head").Part;
                    Pawn.health.RestorePart(part, null, true);
                    Messages.Message(TranslatorFormattedStringExtensions.Translate("MessageBodyPartCuredByItem", part.LabelCap), Pawn, MessageTypeDefOf.PositiveEvent, true);
                }

                //동물
                if (Pawn.def.defName != "Mincho_ThingDef" && !Pawn.health.hediffSet.GetNotMissingParts(0, 0, null, null).Any((BodyPartRecord x) => x.def.defName == "Mincho_Head"))
                {
                    BodyPartRecord part = Pawn.health.hediffSet.GetMissingPartsCommonAncestors().Find((Hediff_MissingPart x) => x.Part.def.defName == "Mincho_Head").Part;
                    Pawn.health.RestorePart(part, null, true);
                    Messages.Message(TranslatorFormattedStringExtensions.Translate("MessageBodyPartCuredByItem", part.LabelCap), Pawn, MessageTypeDefOf.PositiveEvent, true);
                }

                //안점
                if (!Pawn.health.hediffSet.GetNotMissingParts(0, 0, null, null).Any((BodyPartRecord x) => x.def.defName == "Mincho_Eyespot"))
                {
                    BodyPartRecord part = Pawn.health.hediffSet.GetMissingPartsCommonAncestors().Find((Hediff_MissingPart x) => x.Part.def.defName == "Mincho_Eyespot").Part;
                    Pawn.health.RestorePart(part, null, true);
                    Messages.Message(TranslatorFormattedStringExtensions.Translate("MessageBodyPartCuredByItem", part.LabelCap), Pawn, MessageTypeDefOf.PositiveEvent, true);
                }
            }
        }
        public override void PostSpawnSetup(bool respawningAfterLoad)
        {
            base.PostSpawnSetup(respawningAfterLoad);
            Pawn = (parent as Pawn);
        }
        public Pawn Pawn { get; private set; }
    }
}
