﻿using AlienRace;
using HarmonyLib;
using System;
using Verse;
using Verse.AI;

namespace ChangeLook
{
    [StaticConstructorOnStartup]
    public static class ChangeLook_Harmony
    {
        static ChangeLook_Harmony()
        {
            Harmony harmonyInstance = new Harmony("ChangeLook_Harmony");
            harmonyInstance.Patch(AccessTools.Method(typeof(Pawn_AgeTracker), "BirthdayBiological", null, null), null, new HarmonyMethod(patchType, "BirthdayBiologicalPostFix", null), null, null);
            harmonyInstance.Patch(AccessTools.Method(typeof(Pawn_AgeTracker), "RecalculateLifeStageIndex", null, null), null, new HarmonyMethod(patchType, "RecalculateLifeStageIndexPostfix", null), null, null);
            harmonyInstance.Patch(AccessTools.Method(typeof(JobDriver), "Cleanup", null, null), null, new HarmonyMethod(patchType, "CleanupPostfix", null), null, null);
            Log.Message("ChangeLook_patched");
        }

        [HarmonyPostfix]
        public static void BirthdayBiologicalPostFix(Pawn ___pawn)
        {
            foreach (ChangeLookDef changeLook in DefDatabase<ChangeLookDef>.AllDefs)
            {
                if (changeLook.targetRace == ___pawn.def)
                {
                    ThingComp_ChangeLook thingComp_ChangeWithAge = ___pawn.TryGetComp<ThingComp_ChangeLook>();
                    thingComp_ChangeWithAge.bodycheck = true;
                    thingComp_ChangeWithAge.BirthdayBiologicalPostFixTestError = true;
                }
            }
        }

        [HarmonyPostfix]
        public static void RecalculateLifeStageIndexPostfix(Pawn_AgeTracker __instance)
        {
            Pawn value;

            if (Current.ProgramState == ProgramState.Playing && (value = Traverse.Create(__instance).Field("pawn").GetValue<Pawn>()).def is ThingDef_AlienRace && value.Drawer.renderer.graphics.AllResolved)
            {
                foreach (ChangeLookDef changeLook in DefDatabase<ChangeLookDef>.AllDefs)
                {
                    if (changeLook.targetRace == value.def)
                    {
                        ThingComp_ChangeLook thingComp_ChangeWithAge = value.TryGetComp<ThingComp_ChangeLook>();
                        thingComp_ChangeWithAge.bodycheck = true;
                        thingComp_ChangeWithAge.RecalculateLifeStageIndexPostFixTestError = true;
                    }
                }
            }
        }

        [HarmonyPostfix]
        public static void CleanupPostfix(JobDriver __instance)
        {
            if (__instance is JobDriver_UseStylingStation)
            {
                Pawn value;

                if (Current.ProgramState == ProgramState.Playing && (value = Traverse.Create(__instance).Field("pawn").GetValue<Pawn>()).def is ThingDef_AlienRace && value.Drawer.renderer.graphics.AllResolved)
                {
                    foreach (ChangeLookDef changeLook in DefDatabase<ChangeLookDef>.AllDefs)
                    {
                        if (changeLook.targetRace == value.def)
                        {
                            ThingComp_ChangeLook thingComp_ChangeWithAge = value.TryGetComp<ThingComp_ChangeLook>();
                            thingComp_ChangeWithAge.bodycheck = true;
                            thingComp_ChangeWithAge.CleanupxPostFixTestError = true;
                        }
                    }
                }
            }
        }

        private static readonly Type patchType = typeof(ChangeLook_Harmony);
    }
}
