﻿using UnityEngine;
using Verse;

namespace ChangeLook
{
    [StaticConstructorOnStartup]
    public class ChangeLook_Setting : ModSettings
    {
        public override void ExposeData()
        {
            base.ExposeData();
            Scribe_Values.Look(ref OnOffChangeLook, "OnOffChangeLook", true);
            Scribe_Values.Look(ref ChangeLookTestLog, "ChangeLookTestLog", false);
            Scribe_Values.Look(ref ChangeHead, "ChangeHead", false);
            Scribe_Values.Look(ref ChangeHair, "ChangeHair", false);
        }
        public void DoSettingsWindowContents(Rect canvas)
        {
            Listing_Standard listing_Standard = new Listing_Standard
            {
                ColumnWidth = (canvas.width - 34f) / 2f
            };
            listing_Standard.Begin(canvas);

            //ChangeLookDef 비활성화
            listing_Standard.CheckboxLabeled("OnOffChangeLook".Translate(), ref OnOffChangeLook, "OnOffChangeLookToolTip".Translate());
            listing_Standard.Gap(10f);
            listing_Standard.GapLine(10f);

            //ChangeLookDef 테스트 로그 활성화
            listing_Standard.CheckboxLabeled("ChangeLookTestLog".Translate(), ref ChangeLookTestLog, "ChangeLookTestLogToolTip".Translate());
            listing_Standard.Gap(10f);
            listing_Standard.GapLine(10f);

            //ChangeLook 로직 작동시 헤드 변환
            listing_Standard.CheckboxLabeled("ChangeHead".Translate(), ref ChangeHead, "ChangeHeadToolTip".Translate());
            listing_Standard.Gap(10f);
            listing_Standard.GapLine(10f);

            //ChangeLook 로직 작동시 헤어 변환
            listing_Standard.CheckboxLabeled("ChangeHair".Translate(), ref ChangeHair, "ChangeHairToolTip".Translate());
            listing_Standard.Gap(10f);
            listing_Standard.GapLine(10f);

            //끝
            listing_Standard.End();
        }

        public static bool OnOffChangeLook = true;
        public static bool ChangeLookTestLog = false;
        public static bool ChangeHair = false;
        public static bool ChangeHead = false;
    }
}