﻿using HarmonyLib;
using System;
using Verse;
using static Mincho_The_Mint_Choco_Slime.MinchoDefOf;

namespace Mincho_The_Mint_Choco_Slime
{
    [StaticConstructorOnStartup]
    public static class Harmony_AddBaseHediff
    {
        static Harmony_AddBaseHediff()
        {
            Harmony harmonyInstance = new Harmony("Mincho_The_Mint_Choco_Slime");
            harmonyInstance.Patch(AccessTools.Method(typeof(PawnGenerator), "GenerateInitialHediffs", null, null), null, new HarmonyMethod(patchType, "GenerateInitialHediffsPostFix", null), null, null);
            Log.Message("Mincho_The_Mint_Choco_Slime_patched");
        }

        [HarmonyPostfix]
        public static void GenerateInitialHediffsPostFix(Pawn pawn, PawnGenerationRequest request)
        {
            bool flag = pawn.def.defName == "Mincho_Minmoong";
            bool flag2 = pawn.def.defName == "Mincho_Minchonyang";
            bool flag3 = pawn.def.defName == "Mincho_ThingDef";
            if (flag || flag2)
            {
                AddHediff(pawn, Mincho_Animal_AutoRecovery);
            }
            if (flag3)
            {
                AddHediff(pawn, Mincho_Base_Hediff);
                if (pawn.ageTracker.AgeBiologicalYears < 6)
                {
                    AddHediff(pawn, Mincho_Hediff_Small_Mintchoco_Hediff);
                }

                else if (6 <= pawn.ageTracker.AgeBiologicalYears && pawn.ageTracker.AgeBiologicalYears < 18)
                {
                    AddHediff(pawn, Mincho_Hediff_Medium_Mintchoco_Hediff);
                }

                else if (18 <= pawn.ageTracker.AgeBiologicalYears)
                {
                    AddHediff(pawn, Mincho_Hediff_Large_Mintchoco_Hediff);
                }
            }
        }

        private static readonly Type patchType = typeof(Harmony_AddBaseHediff);
    }
}
