﻿using HarmonyLib;
using RimWorld;
using System;
using Verse;
using static Mincho_The_Mint_Choco_Slime.MinchoDefOf;

namespace Mincho_The_Mint_Choco_Slime
{
    [StaticConstructorOnStartup]
    public static class Harmony_FoodUtility
    {
        static Harmony_FoodUtility()
        {
            var harmony = new Harmony("Mincho_The_Mint_Choco_Slime");
            var original = AccessTools.Method(typeof(FoodUtility), nameof(FoodUtility.AddFoodPoisoningHediff));
            var prefix = AccessTools.Method(typeof(Harmony_FoodUtility), nameof(Harmony_FoodUtility.AddFoodPoisoningHediffPrefix));
            harmony.Patch(original, new HarmonyMethod(prefix));
        }

        [HarmonyPrefix]
        public static bool AddFoodPoisoningHediffPrefix(Pawn pawn, Thing ingestible, FoodPoisonCause cause)
        {
            if (pawn.def == Mincho_ThingDef)
            {
                Messages.Message("Mincho_MessageFoodPoisoning".Translate(pawn.LabelShort, ingestible.LabelCapNoCount, cause.ToStringHuman().CapitalizeFirst(), pawn.Named("PAWN"), ingestible.Named("FOOD")).CapitalizeFirst(), pawn, MessageTypeDefOf.NeutralEvent, true);
                return false;
            }

            else return true;
        }
        private static readonly Type patchType = typeof(Harmony_FoodUtility);
    }
}
