﻿using RimWorld;
using System.Collections.Generic;
using Verse;

namespace Mincho_The_Mint_Choco_Slime
{
    public class IngestionOutcomeDoer_GiveHediff_Mincho : IngestionOutcomeDoer_GiveHediff
    {
        protected override void DoIngestionOutcomeSpecial(Pawn pawn, Thing ingested)
        {
            if (witoutThisRace != null)
            {
                for (int i = 0; i < witoutThisRace.Count; i++)
                {
                    if (pawn.def == witoutThisRace[i])
                    {
                        return;
                    }
                }
            }
            if (race == null)
            {
                GiveHediff(pawn);
            }

            else
            {
                for (int i = 0; i < race.Count; i++)
                {
                    if (pawn.def == race[i])
                    {
                        GiveHediff(pawn);
                    }
                }
            }
        }

        private void GiveHediff(Pawn pawn)
        {
            Hediff hediff = HediffMaker.MakeHediff(this.hediffDef, pawn, null);
            float num;
            if (this.severity > 0f)
            {
                num = this.severity;
            }
            else
            {
                num = this.hediffDef.initialSeverity;
            }
            if (divideByBodySize)
            {
                num /= pawn.BodySize;
            }
            AddictionUtility.ModifyChemicalEffectForToleranceAndBodySize(pawn, this.toleranceChemical, ref num);
            hediff.Severity = num;
            pawn.health.AddHediff(hediff, null, null, null);
        }

        public List<ThingDef> race;


        public List<ThingDef> witoutThisRace;

        public bool divideByBodySize = false;
    }
}
