﻿using RimWorld;
using Verse;

namespace Mincho_The_Mint_Choco_Slime
{
    [StaticConstructorOnStartup]
    public static class Mincho_The_Mint_Choco_Slime
    {
        static Mincho_The_Mint_Choco_Slime()
        {
            MinchoDefOf.Mincho_Minmoong.comps.Add(new CompProperties(typeof(MinchoComp)));
            MinchoDefOf.Mincho_Minchonyang.comps.Add(new CompProperties(typeof(MinchoComp)));
            MinchoDefOf.Mincho_MinchoLatteIsHorse.comps.Add(new CompProperties(typeof(MinchoComp)));

            MinchoDefOf.Mincho_Minmoong.comps.Add(new CompProperties(typeof(ThingComp_RemoveGender)));
            MinchoDefOf.Mincho_Minchonyang.comps.Add(new CompProperties(typeof(ThingComp_RemoveGender)));
            MinchoDefOf.Mincho_MinchoLatteIsHorse.comps.Add(new CompProperties(typeof(ThingComp_RemoveGender)));

            MinchoDefOf.Mincho_ThingDef.comps.Add(new CompProperties(typeof(MinchoComp)));
            foreach (ThingDef thingDef in DefDatabase<ThingDef>.AllDefsListForReading.FindAll(delegate (ThingDef x)
            {
                bool result;
                if (x.recipes != null)
                {
                    result = GenCollection.Any<RecipeDef>(x.recipes, (RecipeDef y) => y.defName == "CookMealSimple");
                }
                else
                {
                    result = false;
                }
                return result;
            }))
            {
            }

            foreach (var utility in DefDatabase<ThingDef>.AllDefs)
            {
                if (utility.IsApparel)
                {
                    for (int i = 0; i < utility.apparel.layers.Count; i++)
                    {
                        ApparelLayerDef layer = utility.apparel.layers[i];
                        if (layer == ApparelLayerDefOf.Belt)
                        {
                            MinchoDefOf.Mincho_ThingDef.alienRace.raceRestriction.whiteApparelList.Add(utility);
                            break;
                        }
                    }
                }
            }
        }
    }
}
