﻿using Mincho_HPF;
using RimWorld;
using UnityEngine;
using Verse;
using static Mincho_The_Mint_Choco_Slime.MinchoDefOf;


namespace Mincho_The_Mint_Choco_Slime
{
    [StaticConstructorOnStartup]
    public class Mincho_The_Mint_Choco_Slime_Setting : ModSettings
    {
        public override void ExposeData()
        {
            base.ExposeData();
            Scribe_Values.Look(ref OnOffBrainFreeze, "OnOffBrainFreeze", false);
            Scribe_Values.Look(ref HarvestMintchocoUseAnimals, "HarvestMintchocoUseAnimals", false);
            //Scribe_Values.Look(ref HarvestMintchocoIsSelf, "HarvestMintchocoIsSelf", false);

            //Scribe_Values.Look(ref EICSCTA, "EICSCTA", false, false);
            Scribe_Values.Look<int>(ref IceCreamStack, "IceCreamStack", 10);
            Scribe_Values.Look<float>(ref MintchocoOOH, "MintchocoOOH", 16f);
            Scribe_Values.Look<float>(ref BluePolarBearOOH, "BluePolarBearOOH", 16f);
            Scribe_Values.Look<float>(ref PinkFallInLoveOOH, "PinkFallInLoveOOH", 16f);
            Scribe_Values.Look<float>(ref MintchocoHalfGallonOOH, "MintchocoHalfGallonOOH", 1f);
            Scribe_Values.Look<float>(ref MintchocoDonutOOH, "MintchocoDonutOOH", 16f);
            Scribe_Values.Look<float>(ref MintchocoCakeOOH, "MintchocoCakeOOH", 16f);
            Scribe_Values.Look<float>(ref MintCandyOOH, "MintCandyOOH", -4f);

            Scribe_Values.Look<float>(ref MCJoinBC, "MCJoinBC", 0.25f);
            Scribe_Values.Look<float>(ref BPBJoinBC, "BPBJoinBC", 0.25f);
            Scribe_Values.Look<float>(ref PFILJoinBC, "PFILJoinBC", 0.25f);
            Scribe_Values.Look<float>(ref MNJoinBC, "MNJoinBC", 0.25f);
            Scribe_Values.Look<float>(ref MMJoinBC, "MMJoinBC", 0.25f);
            Scribe_Values.Look<float>(ref MLIHJoinBC, "MLIHJoinBC", 0.25f);
        }
        public void DoSettingsWindowContents(Rect canvas)
        {
            Listing_Standard listing_Standard = new Listing_Standard
            {
                ColumnWidth = (canvas.width - 34f) / 2f
            };
            listing_Standard.Begin(canvas);

            //아이스크림 두통 메시지
            listing_Standard.CheckboxLabeled("OnOffBrainFreeze".Translate("On off ice-cream headache send letter"), ref OnOffBrainFreeze, null);
            listing_Standard.Gap(10f);
            listing_Standard.GapLine(10f);

            //민초 추출을 동물 스킬로
            listing_Standard.CheckboxLabeled("HarvestMintchocoUseAnimals".Translate("Harvest mintchoco use animals"), ref HarvestMintchocoUseAnimals, null);
            listing_Standard.Gap(10f);
            listing_Standard.GapLine(10f);

            ////민초 추출을 셀프로
            //listing_Standard.CheckboxLabeled("HarvestMintchocoIsSelf".Translate("Harvest mintchoco is self"), ref HarvestMintchocoIsSelf, null);
            //listing_Standard.Gap(10f);
            //listing_Standard.GapLine(10f);

            //아이스크림 스택
            listing_Standard.Label("IceCreamStack".Translate(Mincho_Mintchoco.stackLimit.ToString()), -1f, null);
            IceCreamStack = (int)listing_Standard.Slider(IceCreamStack, 10f, 75f);
            listing_Standard.Gap(10f);
            listing_Standard.GapLine(10f);


            //음식 우선순위
            FoodOOHl(listing_Standard, "Mincho_Mintchoco", "MealSimple", ref MintchocoOOH, false, false, 5f);
            FoodOOHl(listing_Standard, "Mincho_BluePolarBear", "MealSimple", ref BluePolarBearOOH, false, false, 5f);
            FoodOOHl(listing_Standard, "Mincho_PinkFallInLove", "MealSimple", ref PinkFallInLoveOOH, true, true);
            FoodOOHl(listing_Standard, "Mincho_MintchocoHalfGallon", "MealSurvivalPack", ref MintchocoHalfGallonOOH);
            FoodOOHl(listing_Standard, "Mincho_MintchocoDonut", "MealFine", ref MintchocoDonutOOH);
            listing_Standard.NewColumn();

            FoodOOHl(listing_Standard, "Mincho_MintchocoCake", "MealLavish", ref MintchocoCakeOOH);
            FoodOOHl(listing_Standard, "Mincho_MintCandy", "Chocolate", ref MintCandyOOH);

            //합류
            JoinBC(listing_Standard, WandererJoin_Mincho, ref MCJoinBC);
            JoinBC(listing_Standard, WandererJoin_BluePolarBear, ref BPBJoinBC);
            JoinBC(listing_Standard, WandererJoin_PinkFallInLove, ref PFILJoinBC);
            JoinBC(listing_Standard, WandererJoin_Mincho_Minmoong, ref MMJoinBC);
            JoinBC(listing_Standard, WandererJoin_Mincho_Minchonyang, ref MNJoinBC);
            JoinBC(listing_Standard, WandererJoin_Mincho_MinchoLatteIsHorse, ref MLIHJoinBC, true);

            //리셋
            if (listing_Standard.ButtonText("ResetAllSetting".Translate(), null))
            {
                OnOffBrainFreeze = false;
                HarvestMintchocoUseAnimals = false;
                //HarvestMintchocoIsSelf = true;

                IceCreamStack = 10;
                MintchocoOOH = 16f;
                BluePolarBearOOH = 16f;
                PinkFallInLoveOOH = 16f;
                MintchocoHalfGallonOOH = 1f;
                MintchocoDonutOOH = 16f;
                MintchocoCakeOOH = 16f;
                MintCandyOOH = -4f;

                MCJoinBC = 0.25f;
                BPBJoinBC = 0.25f;
                PFILJoinBC = 0.25f;
                MNJoinBC = 0.25f;
                MMJoinBC = 0.25f;
                MLIHJoinBC = 0.25f;
            }

            //끝
            listing_Standard.End();
        }
        static Mincho_The_Mint_Choco_Slime_Setting()
        {
            LongEventHandler.ExecuteWhenFinished(delegate ()
            {
                if (HarvestMintchocoUseAnimals)
                {
                    foreach(var comp in MinchoDefOf.Mincho_ThingDef.comps)
                    {
                        if (comp is CompProperties_ResourceHarvestable HPFcomp)
                        {
                            HPFcomp.harvestJobDef = ExtractMincho_IceCream_Animal_Self;
                            //if (HarvestMintchocoIsSelf)
                            //{
                            //    HPFcomp.harvestJobDef = ExtractMincho_IceCream_Animal_Self;
                            //}
                            //else
                            //{
                            //    HPFcomp.harvestJobDef = ExtractMincho_IceCream_Animal;
                            //}
                        }
                    }
                }
                else
                {
                    foreach (var comp in MinchoDefOf.Mincho_ThingDef.comps)
                    {
                        if (comp is CompProperties_ResourceHarvestable HPFcomp)
                        {
                            HPFcomp.harvestJobDef = ExtractMincho_IceCream_Self;
                            //if (HarvestMintchocoIsSelf)
                            //{
                            //    HPFcomp.harvestJobDef = ExtractMincho_IceCream_Self;
                            //}
                            //else
                            //{
                            //    HPFcomp.harvestJobDef = ExtractMincho_IceCream;
                            //}
                        }
                    }
                }


                Mincho_Mintchoco.stackLimit = IceCreamStack;
                Mincho_PinkFallInLove.stackLimit = IceCreamStack;
                Mincho_BluePolarBear.stackLimit = IceCreamStack;

                Mincho_Mintchoco.ingestible.optimalityOffsetHumanlikes = MintchocoOOH;
                Mincho_BluePolarBear.ingestible.optimalityOffsetHumanlikes = MintchocoOOH;
                Mincho_PinkFallInLove.ingestible.optimalityOffsetHumanlikes = MintchocoOOH;

                Mincho_MintchocoHalfGallon.ingestible.optimalityOffsetHumanlikes = MintchocoHalfGallonOOH;
                Mincho_MintchocoDonut.ingestible.optimalityOffsetHumanlikes = MintchocoDonutOOH;
                Mincho_MintchocoCake.ingestible.optimalityOffsetHumanlikes = MintchocoCakeOOH;
                Mincho_MintCandy.ingestible.optimalityOffsetHumanlikes = MintCandyOOH;

                WandererJoin_Mincho.baseChance = MCJoinBC;
                WandererJoin_BluePolarBear.baseChance = BPBJoinBC;
                WandererJoin_PinkFallInLove.baseChance = PFILJoinBC;
                WandererJoin_Mincho_Minchonyang.baseChance = MNJoinBC;
                WandererJoin_Mincho_Minmoong.baseChance = MMJoinBC;
                WandererJoin_Mincho_MinchoLatteIsHorse.baseChance = MLIHJoinBC;
            }
                );
        }

        private static void FoodOOHl(Listing_Standard listing_Standard, string FoodDefName, string ComparedFoodDefName, ref float OriginalOOH, bool writeComparedFoodDefName = true, bool writeGapLine = true, float linegap = 10f)
        {
            var FoodDef = DefDatabase<ThingDef>.GetNamed(FoodDefName);
            var ComparedFoodDef = DefDatabase<ThingDef>.GetNamed(ComparedFoodDefName);
            var StringFoodDefNameOptimalityOffsetHumanlikes = FoodDef.defName + "_OptimalityOffsetHumanlikes";
            var StringComparedFoodDefNameOptimalityOffsetHumanlikes = ComparedFoodDef.defName + "_OptimalityOffsetHumanlikes";
            listing_Standard.Label(StringFoodDefNameOptimalityOffsetHumanlikes.Translate(FoodDef.label, FoodDef.ingestible.optimalityOffsetHumanlikes.ToString()), -1f, null);
            OriginalOOH = (int)listing_Standard.Slider(OriginalOOH, -40f, 40f);

            if (writeComparedFoodDefName)
            {
                listing_Standard.Label(StringComparedFoodDefNameOptimalityOffsetHumanlikes.Translate(ComparedFoodDef.label, ComparedFoodDef.ingestible.optimalityOffsetHumanlikes.ToString()), -1f, null);
            }
            listing_Standard.Gap(linegap);
            if (writeGapLine)
            {
                listing_Standard.GapLine(10f);
            }
        }

        private static void JoinBC(Listing_Standard listing_Standard, IncidentDef JoinDef, ref float OriginalBC, bool writeGapLine = false, float linegap = 3f)
        {
            float TempOriginalBC = OriginalBC * 100;

            var StringJoinDefNameBaceChance = JoinDef.defName + "_BaceChance";
            listing_Standard.Label(StringJoinDefNameBaceChance.Translate(JoinDef.label, JoinDef.baseChance.ToString()), -1f, null);
            TempOriginalBC = (int)listing_Standard.Slider(TempOriginalBC, 1f, 100f);

            OriginalBC = TempOriginalBC / 100;

            listing_Standard.Gap(linegap);
            if (writeGapLine)
            {
                listing_Standard.GapLine(10f);
            }
        }

        public static int IceCreamStack = 10;
        public static float MintchocoOOH = 16f;
        public static float BluePolarBearOOH = 16f;
        public static float PinkFallInLoveOOH = 16f;
        public static float MintchocoHalfGallonOOH = 1f;
        public static float MintchocoDonutOOH = 16f;
        public static float MintchocoCakeOOH = 16f;
        public static float MintCandyOOH = -4f;

        public static float MCJoinBC = 0.25f;
        public static float BPBJoinBC = 0.25f;
        public static float PFILJoinBC = 0.25f;
        public static float MNJoinBC = 0.25f;
        public static float MMJoinBC = 0.25f;
        public static float MLIHJoinBC = 0.25f;

        private Vector2 scrollPosition = new Vector2(0f, 0f);

        //public static bool EICSCTA = false;

        public static bool OnOffBrainFreeze = false;
        public static bool HarvestMintchocoUseAnimals = false; 
        //public static bool HarvestMintchocoIsSelf = false;
    }
}