﻿using System.Collections.Generic;
using System.Linq;
using Verse;

namespace WearSetting
{
    public static class WearSettingMethod
    {
        public static void BoolString(string wearSettingBoolFalseString, string wearSettingBoolTrueString, bool cantBool, out string boolString)
        {
            boolString = wearSettingBoolFalseString ?? "";
            if (cantBool)
            {
                boolString = wearSettingBoolTrueString ?? "(V)";
            }

        }

        public static void WearSettingBoolMaker(WearSetting wearSetting, Pawn pawn, out Condition condition, out bool age, out bool gender, out string genderString, out bool bodyType, out string bodyTypeString, out bool orHediff, out string orHediffString, out bool andHediff, out string andHediffString, out bool forbiddenHediff, out string forbiddenHediffString)
        {
            condition = wearSetting.condition;
            age = condition.age.min <= pawn.ageTracker.AgeBiologicalYears && pawn.ageTracker.AgeBiologicalYears <= condition.age.max;

            //성별
            gender = false;
            if (condition.gender.NullOrEmpty())
            {
                gender = true;
            }
            else foreach (var genderSet in condition.gender)
                {
                    if (pawn.gender == genderSet)
                    {
                        gender = true;
                        break;
                    }
                }
            StringMaker(condition.gender, out genderString);

            //바디타입
            bodyType = false;
            if (condition.bodyTypeDef.NullOrEmpty())
            {
                bodyType = true;
            }
            else foreach (var bodyTypeSet in condition.bodyTypeDef)
                {
                    if (pawn.story.bodyType == bodyTypeSet)
                    {
                        bodyType = true;
                        break;
                    }
                }
            StringMakerForNullLabel(condition.bodyTypeDef, out bodyTypeString);

            List<HediffDef> hediffDefs = (from pawnHediff in pawn.health.hediffSet.hediffs
                                          select pawnHediff.def).ToList();

            //or헤디프
            orHediff = false;
            if (condition.orHediffDef.NullOrEmpty())
            {
                orHediff = true;
            }
            else
            {
                foreach (var item in hediffDefs)
                {
                    if (condition.orHediffDef.Contains(item))
                    {
                        orHediff = true;
                        break;
                    }
                }
            }
            StringMaker(condition.orHediffDef, out orHediffString);

            //And 헤디프
            int match = 0;
            andHediff = false;
            if (condition.andHediffDef.NullOrEmpty())
            {
                andHediff = true;
            }
            else
            {
                foreach (var item in hediffDefs)
                {
                    if (condition.andHediffDef.Contains(item))
                    {
                        match++;
                    }
                }

                if (match >= condition.andHediffDef.Count)
                {
                    andHediff = true;
                }

            }
            StringMaker(condition.andHediffDef, out andHediffString);

            //forbidden 헤디프
            forbiddenHediff = false;
            if (condition.forbiddenHediffDef.NullOrEmpty())
            {
                forbiddenHediff = false;
            }
            else
            {
                foreach (var item in hediffDefs)
                {
                    if (condition.forbiddenHediffDef.Contains(item))
                    {
                        forbiddenHediff = true;
                        break;
                    }
                }
            }
            StringMaker(condition.forbiddenHediffDef, out forbiddenHediffString);

        }
        private static string StringMaker<T>(List<T> condition, out string conditionString)
        {
            conditionString = "";
            for (int i = 0; i < condition.Count; i++)
            {
                if (condition[i] is Def conditionDef)
                {
                    if (i == condition.Count - 1)
                    {
                        conditionString += conditionDef.LabelCap;
                    }
                    else conditionString += conditionDef.LabelCap + "\n\n";
                }
                else
                {
                    if (i == condition.Count - 1)
                    {
                        conditionString += condition[i].ToString();
                    }
                    else conditionString += condition[i].ToString() + "\n\n";
                }
            }

            return conditionString;
        }
        private static string StringMakerForNullLabel<T>(List<T> condition, out string conditionString)
        {
            conditionString = "";
            for (int i = 0; i < condition.Count; i++)
            {
                if (i == condition.Count - 1)
                {
                    conditionString += condition[i].ToString();
                }
                else conditionString += condition[i].ToString() + "\n\n";
            }
            return conditionString;
        }

    }
}
